deleteVariables("$BrickgroupWand::*");
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$BrickgroupWand::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook)
			exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
		RTB_registerPref("Admin Only", "BrickgroupWand", "Pref::BrickgroupWand::AdminOnly", "bool", "Tool_BrickgroupWand", 1, 0, 0);
		RTB_registerPref("Max Bricks (Admin)", "BrickgroupWand", "Pref::BrickgroupWand::MaxBricks", "int 0 50000", "Tool_BrickgroupWand", 5000, 0, 0);
		RTB_registerPref("Max Bricks (Non-Admin)", "BrickgroupWand", "Pref::BrickgroupWand::MaxBricksB", "int 0 50000", "Tool_BrickgroupWand", 500, 0, 0);
		RTB_registerPref("Selecting Timeout (Admin)", "BrickgroupWand", "Pref::BrickgroupWand::SelectionTimeout", "int 0 60", "Tool_BrickgroupWand", 1, 0, 0);
		RTB_registerPref("Selecting Timeout (Non-Admin)", "BrickgroupWand", "Pref::BrickgroupWand::SelectionTimeoutB", "int 0 60", "Tool_BrickgroupWand", 3, 0, 0);
		RTB_registerPref("Max Flood Bypass", "BrickgroupWand", "Pref::BrickgroupWand::FloodIgnore", "int 0 50000", "Tool_BrickgroupWand", 50, 0, 0);
		RTB_registerPref("Trust Required", "BrickgroupWand", "Pref::BrickgroupWand::TrustLevel", "list None " @ $TrustLevel::None @ " Build " @ $TrustLevel::Build @ " Full " @ $TrustLevel::Full @ " You " @ $TrustLevel::You, "Tool_BrickgroupWand", 2, 0, 0);
		RTB_registerPref("Level to make fake groups", "BrickgroupWand", "Pref::BrickgroupWand::CreateLevel", "list None 0 Admin 1 SuperAdmin 2 Host 3", "Tool_BrickgroupWand", 2, 0, 0);
		$BrickgroupWand::PrefsLoaded = true;
	}
}
else
{
	$Pref::BrickgroupWand::AdminOnly = true;
	$Pref::BrickgroupWand::MaxBricks = 5000;
	$Pref::BrickgroupWand::MaxBricksB = 500;
	$Pref::BrickgroupWand::TrustLevel = 2;
	$Pref::BrickgroupWand::SelectionTimeout = 0;
	$Pref::BrickgroupWand::SelectionTimeoutB = 3;
	$Pref::BrickgroupWand::FloodIgnore = 50;
	$Pref::BrickgroupWand::CreateLevel = 2;
}

$Pref::BrickgroupWand::HighlightColor = getClosestPaintColor("1 0.5 0 1");

function createBrickGroup(%BL_ID)
{
	if(strPos(%BL_ID, "Brickgroup") >= 0)
		return -1;

	if(isObject("Brickgroup_" @ %BL_ID))
		return nameToID("Brickgroup_" @ %BL_ID);

	%group = new SimGroup("Brickgroup_" @ %BL_ID)
	{
		client = -1;
		bl_id = %BL_ID;
		name = "\c1BL_ID: " @ %BL_ID;
		QuotaObject = GlobalQuota;
		doNotDelete = 1;
	};
	MainBrickgroup.add(%group);
	return %group;
}

datablock particleData(BrickgroupWandExplosionParticle:DuplorcatorExplosionParticle) {
	colors[0]          = "1 0.7 0.3 0.9";
	colors[1]          = "1 0.5 0.2 0.7";
	colors[2]          = "1 0.4 0 0.5";
	textureName        = "base/data/particles/chunk";
};

datablock particleEmitterData(BrickgroupWandExplosionEmitter:DuplorcatorExplosionEmitter) {
	particles        = BrickgroupWandExplosionParticle;
};

datablock explosionData(BrickgroupWandExplosion:DuplorcatorExplosion) {
	emitter[0]       = BrickgroupWandExplosionEmitter;
	lightStartColor  = "1 0.4 0 1";
};

datablock projectileData(BrickgroupWandProjectile:DuplorcatorProjectile) {
	explosion        = BrickgroupWandExplosion;
};

datablock particleData(BrickgroupWandParticleA:DuplorcatorParticleA) {
	colors[0]          = "1 0.5 0 0.9";
	colors[1]          = "1 0.2 0 0.7";
	colors[2]          = "1 0.4 0.4 0.5";
	textureName        = "base/data/particles/chunk";
};

datablock particleEmitterData(BrickgroupWandEmitterA:DuplorcatorEmitterA) {
	particles        = BrickgroupWandParticleA;
};

datablock particleData(BrickgroupWandParticleB:DuplorcatorParticleB) {
	colors[0]          = "1 0.6 0 0.9";
	colors[1]          = "1 0.2 0 0.7";
	colors[2]          = "1 0.4 0.3 0.5";
	textureName        = "base/data/particles/dot";
};

datablock particleEmitterData(BrickgroupWandEmitterB:DuplorcatorEmitterB) {
	particles        = BrickgroupWandParticleB;
};

datablock itemData(BrickgroupWandItem:DuplorcatorItem) {
   className       = "ItemData"; //stop creating errors b-baka
	colorShiftColor = "1 0.5 0 1";
	image           = "BrickgroupWandImage";
	uiName          = "Brickgroup Wand";
};

datablock shapeBaseImageData(BrickgroupWandImage : wandImage) {
	projectile = BrickgroupWandProjectile;
	showBricks = true;
	colorShiftColor = "1 0.5 0 1";
	item = BrickgroupWandItem;
	stateEmitter[1] = BrickgroupWandEmitterA;
	stateEmitter[3] = BrickgroupWandEmitterB;
};

function BrickgroupWandImage::onStopFire(%this,%player)
{
	%player.stopThread(2);
}

function BrickgroupWandImage::onFire(%this,%player)
{
	%player.playThread(2,armAttack);
	if(%player.client.brickConvertBL_ID <= 100 || %player.client.brickConvertBL_ID > 888888)
	{
		commandToClient(%player.client,'centerPrint',"<color:FF9900>Use /setbgID ID before using this again.",3);
		return;
	}
	%start = %player.getEyePoint();
	%end = vectorAdd(%player.getEyePoint(),VectorScale(%player.getEyeVector(),10));
	%masks = %this.projectile.mask;
	%ray = ContainerRayCast(%start,%end,%masks,%player);
	%hit = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	if(isObject(%hit))
	{
		%p = new Projectile()
		{
			datablock = %this.projectile;
			initialPosition = %pos;
		};
		%p.explode();
		if(%hit.getClassName() !$= "FxDtsBrick")
			return;
		if(!%player.client.isAdmin && $Pref::BrickgroupWand::AdminOnly)
		{
			commandToClient(%player.client,'centerPrint',"<color:FF9900>You must be an \c3Admin<color:FF9900> to use the <color:ffa500>Brickgroup Wand",3);
			return;
		}
		if(getTrustLevel(%hit,%player) < $Pref::BrickgroupWand::TrustLevel)
		{
			commandtoclient(%player.client,'centerPrint',%hit.getGroup().name @ " does not trust you enough to do that.",3);
			return;
		}

		if(%hit.getGroup().bl_id == %player.client.brickConvertBL_ID)
		{
			commandtoclient(%player.client,'centerPrint',"<color:FF9900>These bricks are already converted to the current one you want to switch.",3);
			return;
		}

		if(%player.client.isAdmin)
			%length = $Pref::BrickgroupWand::SelectionTimeout * 1000;
		else
			%length = $Pref::BrickgroupWand::SelectionTimeoutB * 1000;
		if(getSimTime() - %player.lastBGWandTime < %length)
		{
			messageClient(%player.client,'MsgPlantError_Flood');
			%timeout = getSimTime() - %player.lastBGwandTime;
			%timeout = %length - %timeout;
			%timeout /= 1000;
			%timeout = mCeil(%timeout);
			%timeout = %timeout @ " <color:FF9900>" @ (%timeout > 1 ? "seconds":"second");
			commandtoClient(%player.client,'centerprint',"<color:FF9900>You must wait \c3" @ %timeout @ "<color:FF9900> before selecting again",3);
			return;
		}
		%stack = %hit.getBGStack(%player);
		%stack.numBricks = %stack.getCount();
		%b = (%stack.numbricks != 1  ? "bricks":"brick");
		%brickGroup = "Brickgroup_" @ %player.client.brickConvertBL_ID;
		if(!isObject(%brickgroup))
		{
			%client = %player.client;
			%adminLevel = %client.isAdmin + %client.isSuperAdmin + (%client.getBLID() == getNumKeyID() ? 1 : 0);
			if(%adminLevel < $Pref::BrickgroupWand::CreateLevel)
			{
				
				return;
			}
			else
				%brickgroup = createBrickGroup(%player.client.brickConvertBL_ID);
		}
		%player.lastBGWandTime = getSimTime();

		for(%i=0;%i<%stack.numBricks;%i++)
		{
			%brick = %stack.getObject(%i);
			%name = %brick.getName();
			%group = %brick.getGroup();
			%groupC = %group.NTObjectCount[%name];
			%group.remove(%brick);
			if(%brick.getName() !$= "")
			{
				for(%a=0;%a<%groupC;%a++)
				{
					%br = %group.NTObject[%name, %a];
					if(%br == %brick && isObject(%br))
					{
						%group.NTObject[%name, %a] = "0";
						%group.NTObjectCount[%name]--;
					}
				}

				%brCount = 0;
				for(%a=0;%a<%groupC;%a++)
				{
					%br = %group.NTObject[%name, %a];
					if(isObject(%br))
					{
						%br[%a] = %br;
						%brCount++;
					}
				}

				for(%a=0;%a<%brCount;%a++) //Reshift the brick name count
				{
					%br = %br[%a];
					%group.NTObject[%name, %a] = %br;
				}

				//Now to add the brick

				%foundName = 0;
				for(%j=0;%j<mFloor(%brickGroup.NTNameCount);%j++)
				{
					if(%brickGroup.NTName[%j] $= %name)
						%foundName = 1;
				}

				if(!%foundName)
				{
					%brickgroup.NTName[mFloor(%brickgroup.NTNameCount)] = %name;
					%brickgroup.NTNameCount++;
				}

				%foundDuplicate = 0;
				for(%z=0;%z<mFloor(%brickgroup.NTObjectCount[%name]);%z++)
				{
					if(%brickgroup.NTObject[%name, %z] == %brick)
						%foundDuplicate = 1;
				}

				if(!%foundDuplicate)
				{
					%brickgroup.NTObject[%name, mFloor(%brickgroup.NTObjectCount[%name])] = %brick;
					%brickgroup.NTObjectCount[%name]++;
				}
			}

			if(%brick.getDatablock().specialBrickType $= "SpawnPoint")
			{
				%groupSC = %group.spawnBrickCount;

				for(%a=0;%a<%groupSC;%a++)
				{
					%br = %group.spawnBrick[%a];
					if(%br == %brick && isObject(%br))
					{
						%group.spawnBrick[%a] = "0";
						%group.spawnBrickCount--;
					}
				}

				%brCount = 0;
				for(%a=0;%a<%groupSC;%a++)
				{
					%br = %group.spawnBrick[%a];
					if(isObject(%br))
					{
						%br[%a] = %br;
						%brCount++;
					}
				}

				for(%a=0;%a<%brCount;%a++) //Reshift the brickgroup spawn count
				{
					%br = %br[%a];
					%group.spawnBrick[%a] = %br;
				}

				%foundDuplicate = 0;
				for(%z=0;%z<mFloor(%brickgroup.spawnBrickCount);%z++)
				{
					if(%brickgroup.NTObject[%name, %z] == %brick)
						%foundDuplicate = 1;
				}

				if(!%foundDuplicate)
				{
					%brickgroup.spawnBrick[mFloor(%brickgroup.spawnBrickCount)] = %brick;
					%brickgroup.spawnBrickCount++;
				}
			}
			%brickgroup.add(%brick);
		}
		centerprint(%player.client,"<color:ffa500>Brickgroup Wand<br><color:ffa500>" @ %stack.numBricks SPC %b @ "<color:FF9900> converted",3);
		if(%stack.err $= "Limit")
			messageClient(%player.client,'MsgPlantError_Limit');
	}
}

function FxDtsBrick::getBGStack(%brick,%player)
{
	%initialPos = %brick.getPosition();
	if(getTrustLevel(%brick,%player) < $Pref::BrickgroupWand::TrustLevel)
		return;
	%stack = new SimSet();
	%stack.add(%brick);
	%stack.brick0 = %brick.toSaveStr(%initialPos);
	if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate) //marble's hack because logic bricks lel
	{
	  if(isEventPending(%brick.highlightColorReset))
		 cancel(%brick.highlightColorReset);
	  else
	  {
		 %color = %brick.getColorID();
		 %colorFX = %brick.getColorFxID();
		 %brick.setColor($Pref::BrickgroupWand::HighlightColor);
		 %brick.setColorFX(3);
		 %brick.originalColor = %color;
		 %brick.originalColorFX = %colorFX;
	  }
	  %brick.highlightColorReset = %brick.schedule(3000,restoreOrignalColors);
	}
	%final = 1;
	for(%current = 0; %current != %final; %current++)
	{
		if((%player.client.isAdmin && $Pref::BrickgroupWand::MaxBricks <= %stack.getCount()) || (!%player.client.isAdmin && $Pref::BrickgroupWand::MaxBricksB <= %stack.getCount()))
		{
			%stack.err = "Limit";
			return %stack;
		}
		%brick = %stack.getObject(%current);
		if(%current)
		{
			for(%i=0;%i<%brick.getNumDownBricks();%i++)
			{
				%appendBrick = %brick.getDownBrick(%i);
				if(%stack.isMember(%appendBrick) || getTrustLevel(%appendBrick,%player) < $Pref::BrickgroupWand::TrustLevel)
					continue;
			if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate)
			{
			   if(isEventPending(%appendBrick.highlightColorReset))
				  cancel(%appendBrick.highlightColorReset);
			   else
			   {
				  %color = %appendBrick.getColorID();
				  %colorFX = %appendBrick.getColorFxID();
				  %appendBrick.setColor($Pref::BrickgroupWand::HighlightColor);
				  %appendBrick.setColorFX(3);
				  %appendBrick.originalColor = %color;
				  %appendBrick.originalColorFX = %colorFX;
			   }
			   %appendBrick.highlightColorReset = %appendBrick.schedule(3000,restoreOrignalColors);
			}
				%stack.add(%appendBrick);
				%stack.brick[%stack.getCount()-1] = %appendBrick.toSaveStr(%initialPos);
				%final++;
			}
		}
		for(%i=0;%i<%brick.getNumUpBricks();%i++)
		{
			%appendBrick = %brick.getUpBrick(%i);
			if(%stack.isMember(%appendBrick) || getTrustLevel(%appendBrick,%player) < $Pref::BrickgroupWand::TrustLevel)
					continue;
		 if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate)
		 {
			if(isEventPending(%appendBrick.highlightColorReset))
			   cancel(%appendBrick.highlightColorReset);
			else
			{
			   %color = %appendBrick.getColorID();
			   %colorFX = %appendBrick.getColorFxID();
			   %appendBrick.setColor($Pref::BrickgroupWand::HighlightColor);
			   %appendBrick.setColorFX(3);
			   %appendBrick.originalColor = %color;
			   %appendBrick.originalColorFX = %colorFX;
			}
			%appendBrick.highlightColorReset = %appendBrick.schedule(3000,restoreOrignalColors);
		 }
			%stack.add(%appendBrick);
			%stack.brick[%stack.getCount()-1] = %appendBrick.toSaveStr(%initialPos);
			%final++;
		}
	}
	return %stack;
}
function servercmdBrickgroupWand(%client)
{
	if(!%client.isAdmin && $Pref::BrickgroupWand::AdminOnly)
	{
		commandToClient(%client,'centerPrint',"<color:FF9900>You must be an \c3Admin<color:FF9900> to use the <color:ffa500>Brickgroup Wand",3);
		return;
	}

	if(!isObject(%client.player))
		return;
	%client.player.updateArm(BrickgroupWandImage);
	%client.player.mountImage(BrickgroupWandImage,0);
}
function servercmdBGWand(%client)
{
	servercmdBrickgroupWand(%client);
}

function serverCmdsetbgID(%this, %bl_id)
{
	if(!%this.isAdmin && $Pref::BrickgroupWand::AdminOnly)
	{
		%this.chatMessage("<color:FF9900>You must be admin in order to use the convert bl_id.");
		return;
	}

	if(mFloor(%bl_id) == 0)
	{
		if(isObject(%name = findClientByName(%bl_id)))
		{
			%brickGroup = %name.brickgroup;
			if(!isObject(%brickgroup))
			{
				%this.chatMessage("Please pick someone else other than " @ %name.getPlayerName() @ ".");
				return;
			}
			%bl_id = %brickGroup.bl_id;
			%nameStr = " - " @ %brickGroup.name;
		}
		else
		{
			%this.chatMessage("Invalid name.");
			return;
		}
	}

	if(%bl_id <= 100)
	{
		%this.chatMessage("<color:FF9900>That BL_ID is too low.", 3);
		return;
	}

	if(%bl_id > 888888)
	{
		%this.chatMessage("<color:FF9900>That BL_ID is too high.", 3);
		return;
	}

	%this.brickConvertBL_ID = %bl_id;
	%this.chatMessage("ID set it to " @ %bl_id @ %nameStr);
}